\chapter{FAQ}
\label{cap:faq}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% BASE PROGRAMS OPTIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Base programs options} %{{{

\paragraph{How to print more information about what is going on when I execute a GExTools program ?} % {{{

Add \verb!-v! on the GExTools command line.
%}}}

%}}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% DATABASES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Databases} %{{{

\paragraph{I want to store information locally, on files, instead of on a database. Is this possible ?} %{{{

Yes and no. For the moment, all files are stored on the database. However, if these files are found locally (on the indicated \emph{dataDirectory}), they will be used instead of its version on the database.
%}}}

%}}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% BASE CONFIGURATION %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Base configuration} %{{{

\paragraph{What is format used by configuration files ?} %{{{

Configuration files are YAML files.
%}}}

\paragraph{What is the default path for base configuration ?} %{{{

The base configuration files are stored by default in the \verb!database.yml! and \verb!component.yml! files in the configuration folder of GExTools (\emph{.gextools} on your home directory).
%}}}

\paragraph{How could I change the default path for base configuration file ?} %{{{

When running a GExTools program, add \verb!-F PATH! to the command line, with \verb!PATH! the path of your configuration file.
%}}}

\paragraph{How to make a configuration file that contains configuration for connection to the database ?} %{{{

Create a file named \verb!database.yml! in the main directory of GExTools (or just edit it if it already exists) and put:
\begin{lstlisting}  [style=ruby]
VARIABLE:
  adapter: ADAPTER
  database: DB
  host: HOST
  username: LOGIN
  password: PASS
\end{lstlisting}
The \verb!VARIABLE! is a directive informing the following that this configuration will be used when the environment variable \verb!DATABASE_ENV! corresponds to it (Normally, it can be \verb!development! , \verb!test! or \verb!production!).\\
\begin{description}
	\item[ADAPTER] if the type of database to use. For example, if you use MySQL, put \verb!mysql!, if you use sqLite, put \verb!sqLite!. 
	\item[HOST] the hostname of the database to use. If your database server is run locally, put \verb!localhost!.
	\item[LOGIN] the login used to connect to the database.
	\item[PASS] the pass used to connect to the database.
	\item[DB] the name of the database to use.
\end{description}
%}}}

\paragraph{How to make a configuration file that indicates the components I want to use with GExTools programs ?} %{{{

Create a file named \verb!component.yml! in the configuration directory of GExTools (or just edit it if it already exists) and put:
\begin{lstlisting}  [style=ruby]
---
:component: PROGRAM_TYPE
:grid: GRID_TYPE
:gridPasswd: PASSWD
:gridLogin: GRID_LOGIN
:gridHostname: GRID_HOST
\end{lstlisting}
The \verb!---! is a YAML directive saying the following of the file is to be a hash table. It is required to be on top of the file. \\
If you use want to use Somewhere as default program type of component, replace \verb!PROGRAM_TYPE! with \verb!somewhere!. \\
If you use want to use Oar as default grid type of component, replace \verb!GRID_TYPE! with \verb!oar!.
%}}}

\paragraph{What are the entries that can be stored in the database configuration file ? and in the component configuration files ?} %{{{

Cf question \verb!What is the difference between database configuration and component configuration ?!
%}}}

%}}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PROGRAMS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Programs} %{{{
For the following questions/answers, we suppose that you use a base configuration file that contains database-connexion related configurations entries. For each command, you can add the parameter \verb!-v! to have more information about what is going on.

\paragraph{What are the different type of programs installed by default on the GExTools ? What are they used for ?} %{{{
Answer :
\begin{description}
	\item[solver] A somewhere server to be deployed in the \emph{Somewhere}
	\item[answersManager] A program to process queries in the \emph{Somewhere}
	\item[somewhere2] A somewhere server to be deployed in the\emph{Somewhere2}
	\item[generator] A program to generate instances
	\item[sat] A program to process sat satisfiability control on an instance
\end{description}
%}}}

\paragraph{How to register a program type in the database ?} %{{{
Answer : \\
\begin{lstlisting}  [style=bash]
./gexProgs registerType -t PROGRAM_TYPE
\end{lstlisting}
%}}}

\paragraph{How to register a program in the database ?} %{{{
Answer : \\
\begin{lstlisting}  [style=bash]
./gexProgs --name NAME -r VERSION register -p /path/to/program -t PROGRAM_TYPE
\end{lstlisting}
%}}}

\paragraph{How to delete a program in the database ?} %{{{
Answer : \\
\begin{lstlisting}  [style=bash]
./gexProgs --name NAME -r VERSION delete
\end{lstlisting}
%}}}

\paragraph{How to retrieve infos of a registered program in the database ?} %{{{
Answer : \\
If you do not specify a program name  and version using the \verb!-n NAME! \verb!-r VERSION! and parameters, all programs registered for the current component will be shown.
\begin{lstlisting}  [style=bash]
./gexProgs [--name NAME -r VERSION] infos
\end{lstlisting}
%}}}


%}}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% INSTANCES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Instances} %{{{
For the following questions/answers, we suppose that you use a database configuration file that contains database-connexion related configurations entries and a component configuration file that contains information about a given component. For each command, you can add the parameter \verb!-v! to have more information about what is going on.

\paragraph{How to register an instance format in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexInstances registerFormat -f FORMAT_NAME
\end{lstlisting}
%}}}

\paragraph{How to generate a new instance and save it in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexInstances --name NAME generate -g GENERATOR_NAME -G GENERATOR_VERSION -f  INSTANCE_FORMAT -D DESCRIPTION COMPONENT_NAME [SPECIFIC_COMPONENT_GENERATION_PARAMETERS]
\end{lstlisting}
You must give the generator name and version and the generated instance format.
You can add \verb!-s SAT_NAME! and \verb!-s SAT_VERSION! if you want to verify is the instance is satisfiable with the given sat program. \\
\\
For example, if you want to generate a somewhere instance with a generator named swOntoGen (version 1.0), your command line will look like this:
\begin{lstlisting} [style=bash]
./gexInstances -v -n newInstance -d "Barabassi instance. 100 peers with 2 fixed mappings each." -g swontogen -G 1.0-SNAPSHOT -f swr somewhere -s glucose -S 2.0 -N 100 --generatorType BARABASSI -p 70 -P 0.1 -m 2 -M 4 -d 2 -D 10 -t 70,10,10,0,10 -a NONCROSSING -F 2 -i 1 -e 2 -r 42
\end{lstlisting}
%}}}


\paragraph{How to register an already created instance and save it in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexInstances --name NAME register -p PATH_TO_INSTANCE_FILES -f INSTANCE_FORMAT -D DESCRIPTION COMPONENT_NAME [SPECIFIC_COMPONENT_GENERATION_PARAMETERS]
\end{lstlisting}
You can specify a generator name and version, if you want. The parameter \verb!-p PATH_TO_INSTANCE_FILES! is supposed to be the path of a folder that contains instance files, using the format indicated by \verb!-f INSTANCE_FORMAT!. If the format is unknown, there will be an error.
\\
For example, if you want to register a somewhere instance, and don't want to register any information about it, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexInstances --name instance2 register -p /path/to/instance somewhere -f swr -d 'Inconsistent instance with 50 peers.'
\end{lstlisting}
%}}}


\paragraph{How to delete an already stored instance in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexInstances --name NAME delete
\end{lstlisting}
For example, if you want to delete a somewhere instance, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexInstances --name instance3 delete
\end{lstlisting}
%}}}


\paragraph{How to retrieve infos of an already stored instance in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexInstances [--name NAME] infos
\end{lstlisting}
If you do not specify an instance name using the \verb!-n NAME! parameter, all instances registered for the current component will be shown.
For example, if you want to retreive infos of a somewhere instance, your command line will look like this:
\begin{lstlisting} [style=bash]
./gexInstances --name instance3 infos
\end{lstlisting}
%}}}


\paragraph{How to export an already stored instance in the database to a given directory ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexInstances --name NAME export -f FORMAT -p /path/of/where/the/instance/is/to/be/exported
\end{lstlisting}
The parameter \verb!-f FORMAT! correspond to the format you want the instance to be exported to. \\
For example, if you want to export a somewhere instance, on SWR somewhere format, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexInstances --name instance5 export -f SWR -p /path/of/where/the/instance/is/to/be/exported
\end{lstlisting}
%}}}


%}}}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PROBLEMS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Problems} %{{{
For the following questions/answers, we suppose that you use a database configuration file that contains database-connexion related configurations entries and a component configuration file that contains information about a given component. For each command, you can add the parameter \verb!-v! to have more information about what is going on.

\paragraph{How to generate a new problem set and save it in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexProblems --name NAME generate -i INSTANCE_NAME COMPONENT_NAME [SPECIFIC_COMPONENT_QUERIES_GENERATION_PARAMETERS]
\end{lstlisting}
You must give the name of the instance to generate the problems from.\\
\\
For example, if you want to generate a somewhere queries set from an instance named \verb!i1! your command line will look like this:
\begin{lstlisting} [style=bash]
./gexProblems --name q1 generate -i i1  somewhere -t query -q 2 -p 0.5
\end{lstlisting}

Another example, if you want to generate a somewhere mappings set to be added, randomly, on the instance named \verb!i1! your command line will look like this:\\
\begin{lstlisting} [style=bash]
./gexProblems --name q1 generate -i i1  somewhere -t mappingAdd --mappingStrategy random
\end{lstlisting}
%}}}

\paragraph{How to register an already created problem set and save it in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexProblems --name NAME register -p PATH_TO_PROBLEMS_FILE -i INSTANCE_NAME COMPONENT_NAME [SPECIFIC_QUERIES_COMPONENT_REGISTRATION_PARAMETERS]
\end{lstlisting}
You must give the name of the instance the problems are related to. \\
The specific component registration parameters could be given to add details about the nature of the problem set to be registered. \\
\\
For example, if you want to register a somewhere queries set related to an instance named \verb!i1! your command line will look like this:
\begin{lstlisting} [style=bash]
./gexProblems --name q2 register -p /path/to/problem_file -i i1
\end{lstlisting}
The file to be parsed need to be analysed by a specific component. 
\\
Following this idea, in the case of the Somewhere and Somewhere2 components, the problems file need to follow a specific syntax to be correctly parsed:
\begin{lstlisting}
[PROBLEM_TYPE] [PROBLEM_STRING]
[PROBLEM_TYPE] [PROBLEM_STRING]
[PROBLEM_TYPE] [PROBLEM_STRING]
...
\end{lstlisting}
The problem type and the problem string needs to be recognized by the currently chosen component.
\\
For example, a common problem file for the Somewhere or Somewhere2 component could be:
\begin{lstlisting}
QUERY				!P1:E1
MAPPINGADD	!P2:A2&P3:A3
...
\end{lstlisting}
%}}}


\paragraph{How to delete an already stored problem set in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexProblems --name NAME delete
\end{lstlisting}
For example, if you want to delete a somewhere problem set, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexProblems --name q3 delete
\end{lstlisting}
%}}}


\paragraph{How to retrieve infos of an already stored problem set in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexProblems [--name NAME] infos
\end{lstlisting}
If you do not specify a problem set name using the \verb!-n NAME! parameter, all problem sets registered for the current component will be shown.
For example, if you want to retrieve infos of a somewhere queries set, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexProblems --name q4 infos
\end{lstlisting}
%}}}

\paragraph{How to export an already stored problem set in the database to a given file ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexProblems --name NAME export -p /filepath/of/where/the/problems/are/to/be/exported
\end{lstlisting}
For example, if you want to export a somewhere problem set, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexProblems --name q5 export -p /filepath/of/where/the/problems/are/to/be/exported
\end{lstlisting}
%}}}


%}}}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% DEPLOYMENTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Deployments} %{{{
For the following questions/answers, we suppose that you use a database configuration file that contains database-connexion related configurations entries and a component configuration file that contains information about a given component. For each command, you can add the parameter \verb!-v! to have more information about what is going on.

\paragraph{How to register a new deployment, and save it in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexDeploy --name NAME register -p PHYSICAL_CONFIGURATION
\end{lstlisting}
The specific component registration parameters could be given to add details about the nature of the deployment to be registered. \\
The parameter \verb!-p PHYSICAL_CONFIGURATION! represents a list of machines to be deployed. It is, actually, dependant on the grid component. \\
\\
For example, if you want to register an OAR deployment, with 3 processors cores from cluster \verb!sol!, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexDeploy --name d1 register -p sol:rdef=\"core=3\"
\end{lstlisting}
%}}}


\paragraph{How to delete an already stored deployment in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexDeploy --name NAME delete
\end{lstlisting}
For example, if you want to delete a Oar deployment, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexDeploy --name d2 delete
\end{lstlisting}
%}}}


\paragraph{How to retrieve infos of an already stored deployment in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexDeploy [-name NAME] infos
\end{lstlisting}
If you do not specify a deployment name using the \verb!-n NAME! parameter, all deployments registered for the current component will be shown.
For example, if you want to retrieve infos of a deployment, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexDeploy --name d3 infos
\end{lstlisting}
%}}}

\paragraph{How to configure your .ssh config file to use the \emph{Oar} component ?} %{{{
Answer (Extracted from the Grid5000 site): \\
Setup an alias for the global access machine.\\
\begin{lstlisting} [style=bash]
# Alias for the gateway (not really needed, but convenient)
Host g5k
  User YOUR_GRID5K_LOGIN
  Hostname access.grid5000.fr
  ForwardAgent no
\end{lstlisting}
Your are now able to connect to your Grid5000 site without being bothered with options such as to specify your Grid'5000 login each time. After that, you need to setup the glob alias for the access to any hosts inside Grid5000.
\begin{lstlisting} [style=bash]
# Automatic connection to hosts within Grid'5000, and not reachable direction on SSH tcp port 22
Host *.g5k
  User g5k_login
  ProxyCommand ssh g5k "nc -q 0 `basename %h .g5k` %p"
  ForwardAgent no
\end{lstlisting}
The .g5k suffix is an arbitrary suffix you will now specify in your command lines in order to access hosts inside Grid'5000: And now, to log on that gateway.
%}}}


%}}}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% EXPERIMENTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Experiments} %{{{
For the following questions/answers, we suppose that you use a database configuration file that contains database-connexion related configurations entries and a component configuration file that contains information about a given component. For each command, you can add the parameter \verb!-v! to have more information about what is going on.

\paragraph{How to register a new experiment, and save it in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexExperiments --name NAME register -p PROBLEMSET_NAME -d DEPLOYMENT_NAME COMPONENT_NAME [SPECIFIC_QUERIES_COMPONENT_REGISTRATION_PARAMETERS]
\end{lstlisting}
The specific component registration parameters could be given to add details about the nature of the experiment to be registered. \\
For example, if you want to register a Somewhere experiment, on a Oar grid deployment, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexExperiments --name exp0 register -p problemSet0 -d dep0 somewhere -s solver0 -S 1.0 -a am0 -A 1.0
\end{lstlisting}
%}}}

\paragraph{How to delete an already stored experiment in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexExperiments [--name NAME] delete [--executionLabel LABEL]
\end{lstlisting}
For example, if you want to delete a somewhere experiment and all its associated executions and results, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexExperiments --name exp0 delete
\end{lstlisting}

However, if you want to delete a single somewhere experiment execution and all its associated executions and results, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexExperiments --name exp0 delete -l execution1
\end{lstlisting}
%}}}

\paragraph{How to retrieve infos of an already stored experiment in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexExperiments [--name NAME] infos [--executionLabel LABEL]
\end{lstlisting}
If you do not specify a experiment name using the \verb!-n NAME! parameter, all experiments registered for the current component will be shown.
For example, if you want to retrieve infos of a somewhere experiment, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexExperiments --name exp0 infos
\end{lstlisting}

However, if you want to retrieve infos of a single somewhere experiment execution, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexExperiments --name exp0 infos -l execution1
\end{lstlisting}
%}}}

\paragraph{How to execute (i.e deploy with all registered parameters) an already stored experiment in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexExperiments [--name NAME] execute [--executionLabel LABEL --temporaryDeployment DEPLOYMENT --when WHEN_TIME --walltime WALLTIME --executionType EXECUTION_TYPE --vlan] COMPONENT_NAME [SPECIFIC_QUERIES_COMPONENT_REGISTRATION_PARAMETERS]
\end{lstlisting}
The specific component registration parameters could be given to add details about the nature of the experiment to be registered. \\
If the \emph{executionLabel} is not set, the execution will use the current datetime as its identifier.
For example, if you want to execute the somewhere experiment \emph{exp0} at 19:01, on 05/06 of the year 2058 (CET timezone), using 3 hours of walltime, in a sequential way, your command line will look like this:
\begin{lstlisting} [style=bash]
./gexExperiments --name exp0 execute -t '2058-06-05 19:01:00' -w '03:00:00' -e sequential somewhere -d -t 500
\end{lstlisting}
%}}}

\paragraph{How to perform a sat analysis on an already stored instance in the database ?} %{{{
Answer : \\
You need to register and execute an experiment prepared using the SAT component.
\begin{lstlisting} [style=bash]
./gexExperiments --name NAME register -p SAT_PROBLEM_SET -d DEPLOYMENT sat -s SAT_NAME -S SAT_VERSION
\end{lstlisting}
The parameter \verb!-S SAT_NAME! and and \verb!-s SAT_VERSION! correspond to the name of a registered sat program and its version, respectively. \\

For example, if you want to perform sat analysis on a somewhere instance, using a sat program named "sat0" using its "1.0" version, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexExperiments --name experiment4 -p sat_problem_set -d deployment1 sat -s sat0 -S 1.0
\end{lstlisting}

And then, it is only execute the sat experiment:
\begin{lstlisting} [style=bash]
./gexExperiments --name experiment4 execute
\end{lstlisting}
%}}}

%}}}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Results} %{{{

\paragraph{How to retrieve infos about results of experiment executions in the database ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexResults [--name NAME] infos [--executionLabel LABEL]
\end{lstlisting}
For example, if you want to retrieve infos about all the results of a experiment, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexResults --name exp0 infos
\end{lstlisting}

However, if you want to retrieve infos about the results of a single experiment execution, your command line will look like this: \\
\begin{lstlisting}
./gexResults --name exp0 infos -l execution1
\end{lstlisting}
%}}}

\paragraph{How to export experiment results to a given directory ?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexResults --name NAME export -f FORMAT -p /path/of/where/the/instance/is/to/be/exported
\end{lstlisting}

The parameter \verb!-f FORMAT! correspond to the format you want the instance to be exported to. \\
For example, if you want to export all experiment executions results, on XML format, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexResults --name experiment5 export -f XML -p /path/of/where/the/experiment/results/are/to/be/exported
\end{lstlisting}
%}}}

\paragraph{How to export graphs related to an experiment?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexResults --name NAME export -f graphs ... [--exportPath PATH]
\end{lstlisting}

The graphs will be generated in your home folder by default or in the path indicated by \emph{exportPath}. \\
For example, if you want to export graphs related to the execution of the fictitious \emph{experiment1}, exporting the generated graphs to specific location, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexResults --name experiment1 export -f graphs -p /path/of/where/the/graphs/are/to/be/exported
\end{lstlisting}
%}}}

\paragraph{How to generate statistics comparing two or more experiments?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexResults --name NAME compare -e EXP1 ... [--exportPath PATH]
\end{lstlisting}

The comparative graphs will be generated in your home folder by default or in the path indicated by \emph{exportPath}. \\
For example, if you want to compare a fictitious \emph{experiment1} with two other fictitious experiments, exporting the generated graphs to specific location, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexResults --name experiment1 compare -e experiment2 experiment3 -p /path/of/where/the/graphs/are/to/be/exported
\end{lstlisting}
%}}}

\paragraph{How to generate statistics comparing different executions of the same experiment?} %{{{
Answer : \\
\begin{lstlisting} [style=bash]
./gexResults --name NAME compare -x EXEC1 ... [--exportPath PATH]
\end{lstlisting}

The comparative graphs will be generated in your home folder by default or in the path indicated by \emph{exportPath}. \\
For example, if you want to compare executions of the fictitious \emph{experiment1}, exporting the generated graphs to specific location, your command line will look like this: \\
\begin{lstlisting} [style=bash]
./gexResults --name experiment1 compare -x execution1 execution2 -p /path/of/where/the/graphs/are/to/be/exported
\end{lstlisting}
%}}}

%}}}


